#
# gonzui - a source code search engine.
#
# Copyright (C) 2004-2005 Satoru Takabayashi <satoru@namazu.org> 
#     All rights reserved.
#     This is free software with ABSOLUTELY NO WARRANTY.
#
# You can redistribute it and/or modify it under the terms of 
# the GNU General Public License version 2.
#

module Gonzui
  class TopPageServlet < GonzuiAbstractServlet
    def self.mount_point
      "/"
    end

    def validate_request
      return if @request.path_info == "/"
      if @request.path_info == "/favicon.ico"
        url = make_doc_url("favicon.ico")
        @response.set_redirect(HTTPStatus::MovedPermanently, url)
      else
        raise HTTPStatus::NotFound.new("not found")
      end
      assert_not_reached
    end

    def do_GET (request, response)
      init_servlet(request, response)
      validate_request
      log()

      title = "gonzui"
      html = make_html
      head = [:head, [:title, title], make_script, *make_meta_and_css]
      body = [:body]

      content = [:div, {:class => "center"}, 
        make_h1, 
        make_search_form(:central => true),
      ]
      footer = make_footer
      summary = [
        [:br],
        sprintf(_("Searching %s packages of %s files"), 
                commify(@dbm.npackages),
                commify(@dbm.nfiles))
      ]
      footer.push(*summary)
      
      content.push(footer)
      body.push(content)
      html.push(head)
      html.push(body)
      set_content_type_text_html
      response.body = format_html(html)
    end
  end

  GonzuiServlet.register(TopPageServlet)
end

